.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive

include MappedHex.inc

.code

start:
	invoke	GetModuleHandle,NULL
	mov	hInstance,eax
	invoke	InitCommonControls
	invoke	LoadLibrary,addr szLib
	mov		hLib,eax
	invoke	DialogBoxParam,hInstance,IDD_MAIN,NULL,addr DlgProc,NULL
	invoke FreeLibrary,hLib
	invoke	ExitProcess,0

;########################################################################

StreamInProc proc hFile:DWORD,pBuffer:DWORD,NumBytes:DWORD,pBytesRead:DWORD

	.if !nCount
		mov		eax,nBlock
		shl		eax,20
		invoke SetFilePointer,hFile,eax,NULL,FILE_BEGIN
	.endif
	invoke ReadFile,hFile,pBuffer,NumBytes,pBytesRead,0
	inc		nCount
	.if nCount==9
		mov		eax,TRUE
	.else
		xor		eax,1
	.endif
	ret

StreamInProc endp

LoadFile proc
    LOCAL   hFile:DWORD
	LOCAL	editstream:EDITSTREAM
	LOCAL	chrg:CHARRANGE

	;Open the file
	invoke CreateFile,offset FileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	.if eax!=INVALID_HANDLE_VALUE
		mov		hFile,eax
		invoke GetFileSize,hFile,NULL
		mov		FileSize,eax
		;stream the text into the RAHexEd control
		mov		nCount,0
		push	hFile
		pop		editstream.dwCookie
		mov		editstream.pfnCallback,offset StreamInProc
		invoke SendMessage,hHEd,EM_STREAMIN,SF_TEXT,addr editstream
		invoke CloseHandle,hFile
		invoke SendMessage,hHEd,EM_SETMODIFY,FALSE,0
		mov		chrg.cpMin,0
		mov		chrg.cpMax,0
		invoke SendMessage,hHEd,EM_EXSETSEL,0,addr chrg
		mov		eax,nBlock
		inc		eax
		invoke SetDlgItemInt,hWnd,IDC_EDT1,eax,FALSE
		mov		eax,FALSE
	.else
		invoke MessageBox,hWnd,offset OpenFileFail,offset szAppName,MB_OK or MB_ICONERROR
		mov		eax,TRUE
	.endif
	ret

LoadFile endp

OpenEdit proc
	LOCAL	ofn:OPENFILENAME

	;Zero out the ofn struct
	invoke RtlZeroMemory,addr ofn,sizeof ofn
	;Setup the ofn struct
	mov		ofn.lStructSize,sizeof ofn
	push	hWnd
	pop		ofn.hwndOwner
	push	hInstance
	pop		ofn.hInstance
	mov		ofn.lpstrFilter,offset ALLFilterString
	mov		ofn.lpstrFile,offset FileName
	mov		ofn.nMaxFile,sizeof FileName
	mov		ofn.lpstrDefExt,NULL
	mov		ofn.Flags,OFN_FILEMUSTEXIST or OFN_HIDEREADONLY or OFN_PATHMUSTEXIST
	;Show the Open dialog
	invoke GetOpenFileName,addr ofn
	.if eax
		invoke CreateFile,offset FileName,GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
		.if eax!=INVALID_HANDLE_VALUE
			invoke CloseHandle,eax
			invoke LoadFile
		.else
			invoke MessageBox,hWnd,offset OpenFileFail,offset szAppName,MB_OK or MB_ICONERROR
		.endif
	.endif
	ret

OpenEdit endp

DlgProc	proc	hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	mov	eax,uMsg
	.if	eax==WM_INITDIALOG
		;initialization here
		mov		eax,hWin
		mov		hWnd,eax
		invoke GetDlgItem,hWin,IDC_RAH1
		mov		hHEd,eax
	.elseif	eax==WM_COMMAND
		mov edx,wParam
		movzx eax,dx
		shr edx,16
		.if edx==BN_CLICKED
			.if eax==IDC_NEXT
				mov		eax,nBlock
				inc		eax
				shl		eax,20
				.if eax<FileSize
					inc		nBlock
					invoke LoadFile
				.endif
			.elseif eax==IDC_PREVIOUS
				.if nBlock
					dec		nBlock
					invoke LoadFile
				.endif
			.elseif eax==IDM_FILE_OPEN
				invoke OpenEdit
			.elseif eax==IDM_FILE_EXIT
				invoke	EndDialog,hWin,0
			.endif
		.endif
	.elseif	eax==WM_CLOSE
		invoke	EndDialog,hWin,0
	.else
		mov	eax,FALSE
		ret
	.endif
	mov	eax,TRUE
	ret
DlgProc endp

end start
